#include <stdio.h>
#include <fcntl.h>
#include "hdfi.h"
#include "cris.h"
#include "FileTypes.h"
#include "crisPutData.h"
#include "utilities.h"
#include "crisSisPutUtilities.h"

/*

*/

int putCrisBrowseParameters(struct BrowseCris *pDataStruct) {
    unsigned int DATA_TYPE_ID = FILE_CRIS_BROWSE_PARAMETER_V0;
    char FILE_TYPE_SUFFIX[] = "bp0";
    uint32 secondsSince1996 = (uint32) pDataStruct->bin_start;

	/* declared static so memory allocation occurs only once */
    static char dataBuffer[sizeof(struct BrowseCris)];

	/* generalized for all cris data structures beyond this point */
	/*     (assumes all such structs have an identical Second1996 field) */

    int fd, intervalNumber, fileInitialized, status;
    char path[256];

	/* this returns a value to intervalNumber as well as path */
    determineDataFilePathAndCreateDirsAsNeeded(secondsSince1996,
				FILE_TYPE_SUFFIX, path, &intervalNumber, 'C');

    if ((fd = open(path, O_RDWR)) == -1) {
	fileInitialized = 0;
	fd = openOrCreateFileToReadWrite(path);
    }
    else fileInitialized = 1;

    if (!fileInitialized)
	createInitializedFile(fd, dataBuffer, sizeof(dataBuffer), DATA_TYPE_ID);

    status = writeDataStructToFile(fd, intervalNumber, dataBuffer,
				sizeof(dataBuffer), (char *) pDataStruct, path);
    close(fd);
    /* printf("status = %d\n", status); */
    return status;
}
