#include <stdio.h>
#include <string.h>
#include <time.h>
#include "hdfi.h"
#include "utilities.h"
#include "crisSisGetUtilities.h"

void getDataBlockStartAndStopNumbers(int day1996, int fd, char *structName,
			uint32 getStampsAfter, uint32 getStampsUpTo,
			int dataBlocksInFile, int *startAndStopStructNumbers) {
    struct tm *pTm;
    char *buffer;
    uint32 secondsSince1996AtDayStart, timeStamp;
    int secondsIntoDay, dataPeriod, dataBlockNumberInFile, dataBlockSize;

    pTm = getDateFromDay1996(day1996);
	/* make sure we're getting the secondsSince1996 at the day's start */
    pTm->tm_hour = 0;
    pTm->tm_min = 0;
    pTm->tm_sec = 0;
    secondsSince1996AtDayStart = getSecondsSince1996FromDate(pTm);
    secondsIntoDay = (int) (getStampsAfter - secondsSince1996AtDayStart);
    if (secondsIntoDay < 0) secondsIntoDay = 0;

    dataPeriod = getDataTypePeriodFromStructName(structName);
    if (dataPeriod > 0) dataBlockNumberInFile = secondsIntoDay / dataPeriod;
    else dataBlockNumberInFile = 0;

    dataBlockSize = getStructSizeFromName(structName);
    buffer = malloc(dataBlockSize);

	/* step forward through file from here to get right data block */
    lseek(fd, (HEADER_BYTES + (dataBlockNumberInFile * dataBlockSize)), 0);
    for (; dataBlockNumberInFile < dataBlocksInFile; dataBlockNumberInFile++) {
	readFromFile(fd, buffer, dataBlockSize);
	timeStamp = getTimeStamp(buffer, structName);
	if (timeStamp > getStampsAfter) break;
    }

	/* found no valid data block */
    if (dataBlockNumberInFile == dataBlocksInFile) {
	startAndStopStructNumbers[0] = -1;
	startAndStopStructNumbers[1] = -1;
	return;
    }
    else startAndStopStructNumbers[0] = dataBlockNumberInFile;

    secondsIntoDay = (int) (getStampsUpTo - secondsSince1996AtDayStart);
    if (secondsIntoDay >= 86400) secondsIntoDay = 86399;
    if (dataPeriod > 0) dataBlockNumberInFile = secondsIntoDay / dataPeriod;
    else dataBlockNumberInFile = 0;

    lseek(fd, (HEADER_BYTES + (dataBlockNumberInFile * dataBlockSize)), 0);
    for (; dataBlockNumberInFile < dataBlocksInFile; dataBlockNumberInFile++) {
	readFromFile(fd, buffer, dataBlockSize);
	timeStamp = getTimeStamp(buffer, structName);
	if (timeStamp > getStampsUpTo) break;
    }
	/* we went 1 block past the last struct in the time interval	*/
    dataBlockNumberInFile--;

    free(buffer);

    startAndStopStructNumbers[1] = dataBlockNumberInFile;
    return;
}
