#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hdfi.h"
#include "utilities.h"
#include "crisSisGetUtilities.h"

uint32 *getRequestTimesForDaysEvtCycles(int day1996, char instrumentID) {
    uint32 *times;
    uint32 secondsSince1996, timeStamp, time0, nextDays0thTimeStamp, time;
    char structName[50];
    char *pStruct;
    int i;

    if ((instrumentID == 'c') || (instrumentID == 'C'))
					strcpy(structName, "L1CrisEventCycle");
    else if ((instrumentID == 's') || (instrumentID == 'S'))
					strcpy(structName, "L1SisEventCycle");
    else {
	fprintf(stderr, "getTimesToGetDaysEventCycles: instrumentID = ");
	fprintf(stderr, "'%c' invalid.\n\nExiting.\n\n", instrumentID);
	exit(1);
    }

    times = calloc(350, sizeof(uint32 *));
    secondsSince1996 = getSecondsSince1996FromDate(getDateFromDay1996(day1996));
    pStruct = getStruct(secondsSince1996, structName);
    timeStamp = getTimeStamp(pStruct, structName);

	/* usually using second 0 on day1996 will be fine for a time to */
	/* start the list with, but if the 0th struct actually has a */
	/* time stamp equal to this second 0, it might be best to add a */
	/* small offset, just to avoid any problems associated with */
	/* small spacecraft clock glitches (glitches that would cause */
	/* less than 1 second's worth of a drift over the period of a day.) */
    time0 = secondsSince1996;
    if (timeStamp == secondsSince1996) time0 += 10;

    secondsSince1996 =
		getSecondsSince1996FromDate(getDateFromDay1996(day1996 + 1));
    pStruct = getStruct(secondsSince1996, structName);
    timeStamp = getTimeStamp(pStruct, structName);

	/* if the next day's initial time stamp is 0 (0th struct is empty), */
	/* then assign the days 0th second to nextDays0thTimeStamp.  this */
	/* will work fine for our purposes here... */
    if (timeStamp == 0) nextDays0thTimeStamp = secondsSince1996;
    else nextDays0thTimeStamp = timeStamp;

	/* make the list */
    time = time0;
    i = 0;
    while (time < nextDays0thTimeStamp) {
	*(times + i) = time;
	i++;
	time += getDataTypePeriodFromStructName(structName);
    }
    *(times + i) = 0L;
    i++;
    times = realloc(times, (i * sizeof(uint32 *)));
    return times;
}
