#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hdfi.h"
#include "crisSisGetUtilities.h"

uint32 *getTimeStampsOfDaysStructs(int day1996, char *structName) {
    char *pStructs, *pStructsStart;
    uint32 *pStampsStart, *pStamps, startStamp;
    int structCount, structSize;

    pStructsStart = (char *) getDaysStructs(day1996, structName);

    structSize = getStructSizeFromName(structName);
    pStructs = pStructsStart;
    structCount = 0;
    while (getTimeStamp(pStructs, structName)) {
	structCount++;
	pStructs += structSize;
    }

    pStampsStart = calloc((structCount * 2) + 1, sizeof(uint32));

    pStamps = pStampsStart;
    pStructs = pStructsStart;
    while ((startStamp = getTimeStamp(pStructs, structName))) {
	*pStamps = startStamp;
	pStamps++;
	*pStamps = getStopTimeStamp(pStructs, structName);

	    /* avoid confusion with terminal zero value in the array */
	if (*pStamps == 0) *pStamps = -1L;

	pStamps++;
	pStructs += structSize;
    }
    *pStamps = 0L;
    free(pStructsStart);

    return pStampsStart;
}
