#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include "hdfi.h"
#include "sis.h"
#include "FileTypes.h"
#include "sisPutData.h"
#include "crisSisPutUtilities.h"
#include "utilities.h"

/*

*/

int putSisSummaryGroup(struct L1SisSummary *pDataStruct) {
    unsigned int DATA_TYPE_ID = FILE_SIS_L1_SUMMARY;
    char FILE_TYPE_SUFFIX[] = "sum";
    unsigned int TIME_INTERVAL = 1;

	/* declared static so memory allocation occurs only once */
    static char dataBuffer[sizeof(struct L1SisSummary)];

	/* generalized for all sis data structures beyond this point */
	/*     (assumes all such structs have an identical Second1996 field) */

    int fd = -1, intervalNumber, status = -1, day1996;
    char path[256];
    uint32 dayBeginSecond1996 = 0, dayEndSecond1996 = 0, sec1996;
    struct tm *pDate;

    while (pDataStruct->Second1996 > 0) {
	sec1996 = pDataStruct->Second1996;
	/* printf("sec1996 = %d\n", sec1996); */

	    /* is next Second1996 outside the current day? */
	if ((sec1996 < dayBeginSecond1996) || (sec1996 > dayEndSecond1996)) {
	    if (dayBeginSecond1996 != 0) close(fd);
	    determineDataFilePathAndCreateDirsAsNeeded(sec1996,
				FILE_TYPE_SUFFIX, path, &intervalNumber, 'S');
	    /* printf("new path = %s\n", path); */
	    if ((fd = open(path, O_RDWR)) == -1) {
		fd = openOrCreateFileToReadWrite(path);
		createInitializedFileWithIntervalN(fd, dataBuffer,
			sizeof(dataBuffer), DATA_TYPE_ID, TIME_INTERVAL);
	    }

	    day1996 = getDay1996FromSecondsSince1996(sec1996);
	    /* printf("day1996 = %d\n", day1996); */
	    pDate = getDateFromDay1996(day1996);
/*
	    printf("year = %d\n", pDate->tm_year);
	    printf("mon = %d\n", pDate->tm_mon);
	    printf("mday = %d\n", pDate->tm_mday);
	    printf("hour = %d\n", pDate->tm_hour);
	    printf("min = %d\n", pDate->tm_min);
	    printf("sec = %d\n", pDate->tm_sec);
*/
	    dayBeginSecond1996 = getSecondsSince1996FromDate(pDate);
	    /* printf("dayBeginSecond1996 = %d\n", dayBeginSecond1996); */
	    dayEndSecond1996 = dayBeginSecond1996 + (24 * 3600) - 1;
	    /* printf("dayEndSecond1996 = %d\n", dayEndSecond1996); */
	}

	intervalNumber = (sec1996 - dayBeginSecond1996) / TIME_INTERVAL;
	status = writeDataStructToFile(fd, intervalNumber, dataBuffer,
				sizeof(dataBuffer), (char *) pDataStruct, path);

	if (status > 0) {
            fprintf(stderr, "FLAG: abnormal status for data struct");
            fprintf(stderr, " corresponding to\n\tSecond1996 = %ld.", sec1996);
            fprintf(stderr, "  Not necessarily a problem.\n");
            fprintf(stderr, "\tstatus = %d\n", status);
	}

	pDataStruct++;
    }
    close(fd);
    return status;
}
