#include <stdio.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "utilities.h"

    /* procedure to use in case of error (defined below) */
static void localTerminationProcedure(void);


int createDirectory(char *path) {
    if (mkdir(path, 0777) != 0) {
	    /* unable to create this directory */
	fprintf(stderr, "Unable to create directory %s\n", path);
	localTerminationProcedure();
	return 0;
    }
    else return 1;	/* directory created successfully */
}

static void localTerminationProcedure(void) {
    if (getAppTerminatePermission()) {
        fprintf(stderr, "\n\tExiting.\n\n");
        exit(1);
    }
    else {
        fprintf(stderr, "\n\tSERIOUS ERROR!\n\n");
        return;
    }
}
