#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include "utilities.h"

    /* procedure to use in case of error (defined below) */
static void localTerminationProcedure(void);


int fileExists(char *path) {
    struct stat fileStats;
    int fileExists = 0;

    if (stat(path, &fileStats) == -1) {
	if (errno == ENOENT) fileExists = 0;
	else {
	    fprintf(stderr, "stat for %s failed.\n", path);
	    fprintf(stderr, "errno = %d\n", errno);
	    localTerminationProcedure();
	    fileExists = -1;
	}
    }
    else fileExists = 1;

    return fileExists;
}

static void localTerminationProcedure(void) {
    if (getAppTerminatePermission()) {
	fprintf(stderr, "\n\tExiting.\n\n");
	perror("error");
	exit(1);
    }
    else {
	    /* this is a dangerous situation where we don't
		really know whether the file exists or not, and
		permission to terminate the program has been denied.
		if this routine is being used in conjunction with
		creating/writing to a file in the archive,
		corruption may result in the archive by not
		allowing the termination.  the value returned here
		will be -1, which can be checked for specifically,
		but which will otherwise be read as result of true.
		this is the safest way to prevent the overwriting
		of an existing file.  i hope.  programmers denying
		termination permission to the putSis or putCris
		libraries do so at their own risk.
	     */
	fprintf(stderr, "\n\tSERIOUS ERROR!\n\n");
    }
}
