#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "utilities.h"

    /* procedure to use in case of error (defined below) */
static void localTerminationProcedure(char *errorMessage);


int openOrCreateFileToReadWrite(char *path) {
    int fd;
    char CANT_OPEN_ERROR_MSG[] = "Unable to open file %s\n";
    char CANT_CREATE_ERROR_MSG[] = "Unable to create file %s\n";
    char errorMessage[256];

    if ((fd = open(path, O_RDWR, 0)) == -1) {
	    /* the file doesn't exist yet.  create it. */
	if ((fd = creat(path, 0666)) == -1) {
	    sprintf(errorMessage, CANT_CREATE_ERROR_MSG, path);
	    localTerminationProcedure(errorMessage);
	    return -1;
	}
	close(fd);

	if ((fd = open(path, O_RDWR, 0)) == -1) {
		/* still can't open it?  there's a problem. */
	    sprintf(errorMessage, CANT_OPEN_ERROR_MSG, path);
	    localTerminationProcedure(errorMessage);
	    return -1;
	}
    }

    return fd;
}


static void localTerminationProcedure(char *errorMessage) {
    perror("openOrCreateFileToReadWrite\n\t");
    fprintf(stderr, "%s\n", errorMessage);
    if (getAppTerminatePermission()) {
	fprintf(stderr, "\n\tExiting.\n\n");
	exit(1);
    }
    else fprintf(stderr, "\n\tSERIOUS ERROR!\n\n");
}
