#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include "utilities.h"
 
    /* procedure to use in case of error (defined below) */
static void localTerminationProcedure(int bytesToRead, int bytesRead);


int readFromFile(int fd, char *buffer, int bytesToRead) {
    int bytesRead;

    bytesRead = read(fd, buffer, bytesToRead);
    if (bytesRead != bytesToRead) {
	localTerminationProcedure(bytesToRead, bytesRead);
	return -1;
    }
    else return bytesRead;
}

static void localTerminationProcedure(int bytesToRead, int bytesRead) {
    perror("readFromFile\n\t");
    fprintf(stderr, "Tried reading %u bytes, read %u\n", bytesToRead,bytesRead);
    if (getAppTerminatePermission()) {
	fprintf(stderr, "\n\tExiting.\n\n");
	exit(1);
    }
    else fprintf(stderr, "\n\tSERIOUS ERROR!\n\n");
}
