#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include "utilities.h"
 
    /* procedure to use in case of error (defined below) */
static void localTerminationProcedure(int bytesToWrite, int bytesWritten);


int writeToFile(int fd, char *buffer, int bytesToWrite) {
    int bytesWritten;

    bytesWritten = write(fd, buffer, bytesToWrite);
    if (bytesWritten != bytesToWrite) {
	localTerminationProcedure(bytesToWrite, bytesWritten);
	return -1;
    }
    else return bytesWritten;
}

static void localTerminationProcedure(int bytesToWrite, int bytesWritten) {
    perror("writeToFile\n\t");
    fprintf(stderr, "Tried writing %u bytes, wrote %u\n",
						bytesToWrite, bytesWritten);
    if (getAppTerminatePermission()) {
	fprintf(stderr, "\n\tExiting.\n\n");
	exit(1);
    }
    else fprintf(stderr, "\n\tSERIOUS ERROR!\n\n");
}
